﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using System.Net;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services.Protocols;
using System.Web.Services;

namespace WebApplication1
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        public static string sid = "";
        public const long DEFAULT_WORKSPACE = 4;
        //private string username = "neetesh";
        //private string password = "neetesh";

        private string username = "admin";
        private string password = "admin";

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.Cookies["sid"] != null)
            {
                HttpCookie myCookie = new HttpCookie("sid");
                myCookie.Value = String.Empty;
                myCookie.Expires = DateTime.Now.AddDays(-1d);
                Response.Cookies.Add(myCookie);
                Response.Cookies.Remove("sid");
            }

            ReadLoginCredentials();

            try
            {

                // Authenticates once and for all
                Auth.AuthService _auth = new Auth.AuthService();     
                sid = _auth.login(username, password);

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private void ReadLoginCredentials()
        {
            username = ConfigurationManager.AppSettings["Username"];
            password = ConfigurationManager.AppSettings["Password"];

        }

        private void permission(string sid, long folderNo)
        {
            try
            {
                Folder.FolderServiceImplService fservice = new Folder.FolderServiceImplService();

                fservice.getFolder(sid, folderNo);
            }
            catch (Exception ex)
            {
                Response.Redirect(ex.Message.ToString());
            }
        }


        protected void btnLogin_Click(object sender, EventArgs e)
        {
            HttpCookie cookie = new HttpCookie("ldoc-sid");

            //Set the cookies value
            cookie.Value = sid;
            cookie.Path = "http://localhost:8080/";

            //Set the cookie to expire in 10 minute
            DateTime dtNow = DateTime.Now;
            TimeSpan tsMinute = new TimeSpan(0, 0, 10, 0);
            cookie.Expires = dtNow + tsMinute;

            //Add the cookie
            Response.Cookies.Add(cookie);

            HttpCookie cookie1 = new HttpCookie(null);

            //Set the cookies value
            cookie1.Value = "ldoc-sid=" + sid;
            cookie1.Path = "http://localhost:8080/";

            //Set the cookie to expire in 10 minute
            DateTime dtNow1 = DateTime.Now;
            TimeSpan tsMinute1 = new TimeSpan(0, 0, 10, 0);
            cookie1.Expires = dtNow1 + tsMinute1;

            //Add the cookie
            Response.Cookies.Add(cookie1);
            Response.Redirect("http://localhost:8080/logicaldoc", false);
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            const int READ = 1;
            const int WRITE = 2;
            const int ADD = 4;
            const int SECURITY = 8;
            const int IMMUTABLE = 16; // you can turn the documents in folder to immutable
            const int DELETE = 32;
            const int RENAME = 64;
            const int IMPORT = 128;
            const int EXPORT = 256;
            const int SIGNATURE = 512;
            const int ARCHIVE = 1024;
            const int WORKFLOW = 2048;
            const int DOWNLOAD = 4096;
            const int CALENDAR = 8192;

            long userID = 3440641; // The user must exists!
            try
            {
                Folder.FolderServiceImplService fservice = new Folder.FolderServiceImplService();
                long folderID = fservice.createFolder(sid, 4, "New Folder");


                int permissions = READ ^ EXPORT; // this is a XOR operation

                fservice.grantUser(sid, folderID, userID, permissions, false);
            }
            catch (Exception ex)
            {
                Response.Write(ex.Message.ToString());
            }
        }

        protected void btnAccess_Click(object sender, EventArgs e)
        {
            long fno = 3506176;
             List<string> colors = new List<string>();
             Folder.FolderServiceImplService fservice = new Folder.FolderServiceImplService();
            if(sid !="")
            {
               
                fservice.listChildren(sid, 4);
                Response.Redirect("http://localhost:8080/logicaldoc?sid=" + sid + "&appender = DMS_WEB");
               // permission(sid, fno);
            }
        }
     
    }
}